#include <stdio.h>
#include <math.h>

/*
-------------------------------------------------------------------------------
Regressio exponencial
-------------------------------------------------------------------------------
Dades: Fitxer "expo.dat" amb dues columnes, x i y, respectivament.
Resultats: a,b (y=a*exp(bx))
Dades de prova: 1, 40.17; 2, 806.9; 3, 1.621e4 ==> a=1.999656 b=3.000130
Observacions: si no funciona, prova a compilar amb l'opcio -lm
------------------------------------------------------------------------------- 
*/

main()
{
int i,j,comptador,final;
float a,b,s,sx,sy,sxx,syy,sxy,x[200],y[200];
FILE *arxiu;

arxiu=fopen("expo.dat","r");
comptador=0;
while(!feof(arxiu))
	{
	fscanf(arxiu,"%f %f",&x[comptador],&y[comptador]);
	printf("%f %f\n",x[comptador],y[comptador]);
	comptador++;
	}
fclose(arxiu);
comptador=comptador-1;
s=0.0;
sx=0.0;
sy=0.0;
sxx=0.0;
syy=0.0;
sxy=0.0;
for(i=0;i<comptador;i++)
	{
	y[i]=log(y[i]);
	s=s+1;
	sx=sx+x[i];
	sxx=sxx+x[i]*x[i];
	sy=sy+y[i];
	syy=syy+y[i]*y[i];
	sxy=sxy+x[i]*y[i];
	}
a=(sxx*sy-sx*sxy)/(s*sxx-sx*sx);
b=(s*sxy-sx*sy)/(s*sxx-sx*sx);
printf("a=%f b=%f\n",exp(a),b);
}
